/* Example: passing 2-D arrays to functions */

#include <stdio.h>

void print_mat(int M[3][3]);  /* Prints 3 x 3 matrix M */

void multiply(int P[3][3], int M1[3][3], int M2[3][3]);
/* Multiplies 3 x 3 matricies: P = M1.M2 */


void main(void)
{
  int A[3][3] = {{2,  4,  6},
                 {0, -1,  3},
                 {5,  2, -1}};
     
  int B[3][3] = {{1,  3, -2},
                 {3,  0,  2},
                 {1, -3,  4}};

  int C[3][3];
  
  puts("matrix A:");
  print_mat(A);
  
  puts("matrix B:");
  print_mat(B);

  /* multiply C = A.B: */
  
  multiply(C, A, B);
  puts("product A.B:");
  print_mat(C);
  
  return;
}


void print_mat(int M[3][3])  /* Prints 3 x 3 matrix M */
{
  int i;

  for (i = 0; i < 3; i++)
  {
    printf("[ %3i", M[i][0]);
    printf("  %3i", M[i][1]);
    printf("  %3i ]\n", M[i][2]);
  }
  putchar('\n');
  return;
}


void multiply(int P[3][3], int M1[3][3], int M2[3][3])
{                         /* Multiplies 3 x 3 matricies: P = M1.M2 */
  int i, j, k;
  
  for (i = 0; i < 3; i++)
    for (j = 0; j < 3; j++)
    {
      P[i][j] = 0;
      for (k =0; k < 3; k++)
        P[i][j] += M1[i][k] * M2[k][j];
    }
return;
}
